#include "vs1103.h"

// u_int16 ClockSdi(void) {
	.sect code,ClockSdi	// 20 words
	.export _ClockSdi
_ClockSdi:
	ldc 32-1,A0
	ldc SER_DREQ,I7
$0:	ldc 1,I5	// for timing
	add A0,ONES,A0	; stx I5,(I7)
	ldc 0,I5	// for timing
	jnc $0
	stx I5,(I7)
	jr
#if 1
	nop
#else
	//Pull in our SDI interrupt, if it were in some other file
	.import my_sdi_int
	ldc my_sdi_int,i5
#endif

#if 0
	/* does not work -- returns too fast after STX?! */
	ldc 32-1,A0
	ldc SER_DREQ,I7
$0:	ldc 1,I5	// for timing
	add A0,ONES,A0	; stx I5,(I7)
	ldc 0,I5	// for timing
	jrns
	stx I5,(I7)
	jmpi $0
#endif


	.sect code,sdi_int
	.export my_sdi_int
my_sdi_int:
	stx mr0,(i6)+1	; sty i7,(i6)
	stx a0,(i6)	; sty b0,(i6)

	ldc SER_DATA,i7
	lsr ones,b0	; ldx (i7),a0
	.import _ui
	ldc _ui+0/*Data*/,i7
	lsrc a0,a0	; ldy (i6),b0		// 0x8000 or 0xffff;

	sty a0,(i7)	; ldx (i6)-1,a0

	ldc INT_GLOB_ENA,i7
	ldx (i6),mr0
	reti
	stx i7,(i7); ldy (i6)-1,i7


	/* SDI vector updated AFTER the handler is loaded, thus is ok */
	.sect code,int_vectors
	.org 0x22
	jmpi my_sdi_int,(i6)+1	// SDI	0x22




	.end

